''' Lutz Ifers WinAPI-Tutorial
'''
''' Kapitel 3.1 - "Tastatur"

#include "windows.bi"
const ProgrammName = "Tastatur"

declare function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT

dim shared as byte Key(255)

dim as WNDCLASS	wcMeinFenster
with wcMeinFenster
    .style         =  CS_HREDRAW or CS_VREDRAW
    .lpfnWndProc   =  ProcPtr(Fenster)
    .cbClsExtra    =  0
    .cbWndExtra    =  0
    .hInstance     =  GetModuleHandle(NULL)
    .hCursor       =  LoadCursor(NULL, IDC_ARROW)
    .hIcon         =  LoadIcon(NULL, IDI_APPLICATION)
    .hbrBackground =  GetStockObject(WHITE_BRUSH)
    .lpszClassName =  StrPtr(ProgrammName)
    .lpszMenuName  =  NULL
end with
RegisterClass @wcMeinFenster

dim as HWND	hMeinFenster = CreateWindow(_
    ProgrammName, "Titelzeile", WS_OVERLAPPEDWINDOW,_
    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,_
    NULL, NULL, GetModuleHandle(NULL), NULL)

ShowWindow   hMeinFenster, SW_NORMAL
UpdateWindow hMeinFenster

dim as MSG msg
do while getmessage(@msg, NULL, 0, 0) <> 0
    DispatchMessage  @msg
    TranslateMessage @msg
loop
end msg.wParam
function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
    
    static as STRING    sText
    
    select case message
        case WM_DESTROY
            PostQuitMessage 0
            return 0
            
        case WM_KEYDOWN
            Key(wParam) = TRUE
            InvalidateRect hWnd, NULL, TRUE
            return 0
            
        case WM_KEYUP
            Key(wParam) = FALSE
            InvalidateRect hWnd, NULL, TRUE
            return 0
        case WM_CHAR
            select case wParam
                case  9, 10, 27
                case 13 :   sText = ""
                case  8 :   if len(sText) > 0 then 
                                sText = left(sText, len(sText) - 1)
                            end if
                case else : sText += chr(wParam)
            end select
            InvalidateRect hWnd, NULL, TRUE
            return 0
        case WM_PAINT
            dim as INTEGER      i
            dim as STRING       sTasten = "Gedrckte Tasten: "
            dim as PAINTSTRUCT  ps
            
            for i = 0 to 255
                if Key(i) = TRUE then sTasten += chr(i, 32)
            next
            
            dim as HDC hDC = BeginPaint(hWnd, @ps)
                TextOut hDC, 5,  5, sTasten, len(sTasten)
                TextOut hDC, 5, 26, sText, len(sText)
            EndPaint(hWnd, @ps)
            return 0
    end select
    
    return DefWindowProc(hWnd, message, wParam, lParam)
end function
