''' Lutz Ifers WinAPI-Tutorial
'''
''' Kapitel 3.2 - "Maus"

#include "windows.bi"
const ProgrammName = "Maus"

declare function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT

dim as WNDCLASS	wcMeinFenster
with wcMeinFenster
    .style         =  CS_HREDRAW or CS_VREDRAW
    .lpfnWndProc   =  ProcPtr(Fenster)
    .cbClsExtra    =  0
    .cbWndExtra    =  0
    .hInstance     =  GetModuleHandle(NULL)
    .hCursor       =  LoadCursor(NULL, IDC_ARROW)
    .hIcon         =  LoadIcon(NULL, IDI_APPLICATION)
    .hbrBackground =  GetStockObject(WHITE_BRUSH)
    .lpszClassName =  StrPtr(ProgrammName)
    .lpszMenuName  =  NULL
end with
RegisterClass @wcMeinFenster

dim as HWND	hMeinFenster = CreateWindow(_
    ProgrammName, "Titelzeile", WS_OVERLAPPEDWINDOW,_
    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,_
    NULL, NULL, GetModuleHandle(NULL), NULL)

ShowWindow   hMeinFenster, SW_NORMAL
UpdateWindow hMeinFenster

dim as MSG msg
do while getmessage(@msg, NULL, 0, 0) <> 0
    DispatchMessage  @msg
loop
end msg.wParam
function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
    
    static as POINT ptStart, ptEnde
    dim    as HDC   hDC
    
    select case message
        case WM_DESTROY
            PostQuitMessage 0
            return 0
            
        case WM_LBUTTONDOWN
            ptStart.x = LOWORD(lParam)
            ptStart.y = HIWORD(lParam)
            hDC = GetDC(hWnd)
                Ellipse hDC, ptStart.x - 5, ptStart.y - 5,_
                    ptStart.x + 5, ptStart.y + 5
                
            ReleaseDC hWnd, hDC
            return 0
            
        case WM_LBUTTONUP
            ptEnde.x = LOWORD(lParam)
            ptEnde.y = HIWORD(lParam)
            hDC = GetDC(hWnd)
                Ellipse hDC, ptEnde.x - 5, ptEnde.y - 5,_
                    ptEnde.x + 5, ptEnde.y + 5
                
            ReleaseDC hWnd, hDC
            return 0
        case WM_MOUSEMOVE
            if (wParam and MK_LBUTTON) <> 0 then
                ptEnde.x = LOWORD(lParam)
                ptEnde.y = HIWORD(lParam)
                InvalidateRect hWnd, NULL, TRUE
            end if
            return 0
            
        case WM_PAINT
            dim as PAINTSTRUCT  ps
            dim as STRING sText = "Maus: "+str(ptEnde.x)+", "+str(ptEnde.y)
            hDC = BeginPaint(hWnd, @ps)
                TextOut hDC, 0, 0, sText, len(sText)
                MoveToEx hDC, ptStart.x, ptStart.y, NULL
                LineTo hDC, ptEnde.x, ptEnde.y
            EndPaint(hWnd, @ps)
            return 0
    end select
    
    return DefWindowProc( hWnd, message, wParam, lParam )    
end function
