''' Lutz Ifers WinAPI-Tutorial
'''
''' Kapitel 4.2 - "Childwindows"

#include "windows.bi"
const ProgrammName = "Childwindows"
const ChildfensterName = "Child"

declare function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
declare function ChildFenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT

dim as WNDCLASS	wcMeinFenster
with wcMeinFenster
    .style         =  CS_HREDRAW or CS_VREDRAW
    .lpfnWndProc   =  ProcPtr(Fenster)
    .cbClsExtra    =  0
    .cbWndExtra    =  0
    .hInstance     =  GetModuleHandle(NULL)
    .hCursor       =  LoadCursor(NULL, IDC_ARROW)
    .hIcon         =  LoadIcon(NULL, IDI_APPLICATION)
    .hbrBackground =  GetStockObject(LTGRAY_BRUSH)
    .lpszClassName =  StrPtr(ProgrammName)
    .lpszMenuName  =  NULL
end with
RegisterClass @wcMeinFenster


dim as WNDCLASS	wcChildFenster
with wcChildFenster
    .style         =  CS_HREDRAW or CS_VREDRAW
    .lpfnWndProc   =  ProcPtr(Childfenster)
    .cbClsExtra    =  0
    .cbWndExtra    =  0
    .hInstance     =  GetModuleHandle(NULL)
    .hCursor       =  LoadCursor(NULL, IDC_ARROW)
    .hIcon         =  LoadIcon(NULL, IDI_APPLICATION)
    .hbrBackground =  GetStockObject(WHITE_BRUSH)
    .lpszClassName =  StrPtr(ChildfensterName)
    .lpszMenuName  =  NULL
end with
RegisterClass @wcChildFenster

dim as HWND	hMeinFenster = CreateWindow(_
    ProgrammName, "Titelzeile", WS_OVERLAPPEDWINDOW,_
    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,_
    NULL, NULL, GetModuleHandle(NULL), NULL)

ShowWindow   hMeinFenster, SW_NORMAL
UpdateWindow hMeinFenster

dim as MSG msg
do while getmessage(@msg, NULL, 0, 0) <> 0
    DispatchMessage  @msg
loop
end msg.wParam
function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
    
    static as HWND hFensterA, hFensterB, hFensterC, hFensterD
    
    select case message
        case WM_DESTROY
            PostQuitMessage 0
            return 0
            
        case WM_CREATE
            hFensterD = CreateWindow(ChildfensterName,_
                "Schieb mich",_
                WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_OVERLAPPEDWINDOW ,_
                10, 120, 320, 100,_
                hWnd, NULL, cast(LPCREATESTRUCT,lParam)->hInstance, NULL)

            hFensterA = CreateWindow(ChildfensterName,_
                "Ohne Alles",_
                WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS,_
                10, 10, 100, 100,_
                hWnd, NULL, cast(LPCREATESTRUCT,lParam)->hInstance, NULL)
                
            hFensterB = CreateWindow(ChildfensterName,_
                "Rand",_
                WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER,_
                120, 10, 100, 100,_
                hWnd, NULL, cast(LPCREATESTRUCT,lParam)->hInstance, NULL)
                
            hFensterC = CreateWindow(ChildfensterName,_
                "Viel Rand",_
                WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_DLGFRAME,_
                230, 10, 100, 100,_
                hWnd, NULL, cast(LPCREATESTRUCT,lParam)->hInstance, NULL)
            return 0
    end select
    return DefWindowProc( hWnd, message, wParam, lParam )    
end function
function Childfenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
    
    select case message
        case WM_PAINT
            dim as ZSTRING*100  text
            dim as PAINTSTRUCT  ps
            dim as HDC hDC = BeginPaint(hWnd, @ps)
                GetWindowText hWnd, text, sizeof(text)
                TextOut hDC, 5, 5, text, len(text)
            EndPaint hWnd, @ps
            return 0
    end select
    return DefWindowProc(hWnd, message, wParam, lParam)
end function
